#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <cmath>
#include <signal.h>

#include <vector>
#include <iostream>
#include <iomanip>
#include <stdexcept>

#include "curtain.h"

const std::string   sect_device("Devices");

const AWord Curtain::GET_POWER_VOLTAGE = 0xfc;
const AWord Curtain::GET_TEMPERATURE = 0xfa;

Curtain::Curtain( Config& cfg, RS485& r, const std::string& s ) : Module( cfg, r, s ) {
    factors.actuat_voltage = cfg.inp<double>( sect_device, s, "ActVoltFactor");
    factors.actuat_temper  = cfg.inp<double>( sect_device, s, "ActTempFactor");
    shifts.actuat_temper   = cfg.inp<double>( sect_device, s, "ActTempShift");
}

Curtain::~Curtain() {
//    std::cerr << "Destructor Curtain" << std::endl;
}

void Curtain::getData( MonitorInfo& c ) {
    c.actuat_voltage = factors.actuat_voltage*askWord( GET_POWER_VOLTAGE);
    c.actuat_temper  = factors.actuat_temper*askWord( GET_TEMPERATURE )-shifts.actuat_temper;
}
