#ifndef _DEFTYP_H
#define _DEFTYP_H
#include <vector>
#include <string>

#include <infratypes.h>

struct MonitorInfo {
    double temperature1;
    double temperature2;
    double wind_speed;
    double wind_direction;
    double wind_max;
    double humidity;
    double pressure;
    double dew_point;
    double generator_rps;
    double accum_voltage;
    double actuat_voltage;
    double actuat_temper;
    bool   switch1;
    bool   switch2;
    bool   power_main;
    bool   power_core;
    bool   power_netp;
    double skys_amb;
    double skys_sens;
    double skys_sky;
    int    skys_stat;
    MonitorInfo() : temperature1(0), temperature2(0), wind_speed(0), wind_direction(0),
        wind_max(0), humidity(0), pressure(0), dew_point(0), generator_rps(0),
        accum_voltage(0), actuat_voltage(0), actuat_temper(0), switch1(true), switch2(true),
        power_main(true), power_core(true), power_netp(true), skys_amb(0), skys_sens(0), skys_sky(0), skys_stat(0) {}
};

#endif
