#ifndef _COMMS_H
#define _COMMS_H
#include <string>
#include <vector>
#include <memory>

#include <server.h>

class Client;

struct TASK {
    Client* source;
    std::string id;
    std::string comm;
    std::vector<std::string> params; 
    TASK(){}
    TASK( Client* s, const std::string i, const std::string c, const std::vector<std::string> p) 
        : source(s), id(i), comm(c), params(p) {}
};

class Lock {
private:
    static pthread_mutex_t progress;
    Lock(const Lock&);
    Lock& operator=(const Lock&);
public:
    Lock();
    ~Lock() { pthread_mutex_unlock(&progress); }
    static bool busy();
};

namespace Comm {
    int cmd_line( int ac, char **av );
    ServerSocket::AddrType& deviceServer();
    std::string call_command( Client*, std::string );
    std::string init( std::auto_ptr<TASK> );
    std::string  run( std::auto_ptr<TASK> );
    std::string stop( std::auto_ptr<TASK> );
    std::string  set( std::auto_ptr<TASK> );
    std::string  get( std::auto_ptr<TASK> );
    std::string park( std::auto_ptr<TASK> );
    std::string quit( std::auto_ptr<TASK> );
    bool deviceWatch();
    void terminate();
}

#endif
