#ifndef _CONFIGS_H
#define _CONFIGS_H

#include <string>
#include <map>
#include <vector>
#include <sstream>
#include <errlog.h>
#include <coordinates.h>

/** \file configs.h 
      ,   . */
/**      */
class Cmpi  {
public:
    bool operator()( const std::string& , const std::string& ) const;
};

/**        .
     varSubsect[" "] */
typedef std::map<std::string,std::vector<std::string>,Cmpi> Subsection;

/**         
.      varSect[" "][" "] */
typedef std::map<std::string,Subsection,Cmpi> Section;

/**         .
     varThreeMap[" "][" "][" "] */
typedef std::map<std::string,Section,Cmpi> Tree;

///         ThreeMap.

//     /**
//            Tree
//     \param fname   
//     \param m      Tree
//     
//             (Section "sname" 
//     SubSection "ssname"),     EndSection  EndSubSection, 
//            .  
//       ,    , 
//       Config::parse().    tokens 
//       : m["sname"]["ssname"][tokens[0]] = tokens.
//      ,   -     -
//             ..   
//      ,        
//     (   )       
//      .
//     
//     :    ,  
//     Error::Skipped(fname,0,"file not found").     , 
//          stderr,    - 
//     .     . 
//     */
//     int fileRead( const char *fname, ThreeMap& m);
//     

//     /**
//           ()
//     \param cs C- 
//     \param item    C++-,    
//     \return  
//     
//        \a cs      ,
//           ";"  "#",   
//         backslash    (\" --> '').
//             (
//     "seeing=2\"").        
//     .  ,         
//     , ""     ( 
//       ,       
//      Supervisor). ,    ,  
//      ,     \a item. 
//     */
//     bool parse( const char *cs, std::vector<std::string>& item );

class   Config {
    Tree  conf;
    std::vector<std::string>  Prow;
public:
    Config( const std::string& filename );
    ~Config(){} // std::cerr << " Config\n"; }
    /**     class T \\s\\ss\\e   ,
    \note         1 -
      Error::Skipped.
    */
    Geo site_coords();
    bool issection( const std::string& );
    bool issubsection( const std::string& , const std::string& );
    bool isparameter( const std::string&, const std::string&, const std::string& );
    std::string Pstr( int i) { return Prow.at(i);}
    int size() { return Prow.size();}
    std::string copy(const std::string& sect, const std::string& subs, const std::string& item ); 
    template<class T> T inp( const std::string& sect, const std::string& subs, const std::string& item ){
/*        if( !isparameter( sect, subs, item ) ) {
            throw ErrFat( ERR_CFG_MISSED, sect + "/" + subs + "/" + item );
        }
        std::vector<std::string> *values = &conf[sect][subs][item];*/
        T ret;
        if( isparameter( sect, subs, item ) && conf[sect][subs][item].size() == 2 ){
            std::istringstream iss(conf[sect][subs][item].at(1));
            iss.unsetf(std::ios::dec);
            iss.setf(std::ios::boolalpha);
            iss >> ret;
        } else {
            throw ErrFat( ERR_CFG_MISSED, sect + "/" + subs + "/" + item );
        }
        return ret;
    };
    template<class T> std::vector<T> inpv( const std::string& sect, const std::string& subs, const std::string& item ){
//        std::vector<std::string> *values = &conf[sect][subs][item];
        std::vector<T> ret;
        T dummy;
        if( isparameter( sect, subs, item ) && conf[sect][subs][item].size() >= 2 ){
            ret.resize( conf[sect][subs][item].size()-1 );
            for( unsigned int i = 0; i < conf[sect][subs][item].size()-1; i++ ) {
                std::istringstream iss( conf[sect][subs][item].at(i+1) );
                iss.unsetf(std::ios::dec);
                iss.setf(std::ios::boolalpha);
                iss >> dummy;
                ret.at(i) = dummy;
            }
        } else {
            throw ErrFat( ERR_CFG_MISSED, sect + "/" + subs + "/" + item );
        }
        return ret;
    };
};

namespace Tool {
    int parse( const char *, std::vector<std::string>& );
    int item_cnt( const char * );
    void decompress( std::string& );
}

#endif
