#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <valarray>
#include <iostream>
#include <iomanip>
#include <vector>
#include <numeric>
//#include <signal.h>

#include "sensors.h"
#include "modes.h"

const double spar_time=1.0;

const std::string   sect_operation("Operations");
const std::string   subs_monitor("Monitor");

Mode::Mode( Config &cf, Device &cm ) {
    cfg = &cf;
    ddv = &cm;
//    std::cerr << "Mode ";
}

Monitor::Monitor( Config& cf, Device& cm, Result& out ) : Mode( cf, cm ) {
    up_time = 0.0;
    ddv->set_out( &out );
    scan_period  = cfg->inp<double>( sect_operation, subs_monitor, "ScanPeriod");
    accum_time   = cfg->inp<double>( sect_operation, subs_monitor, "AccumTime");
    ddv->monitor_run( scan_period, accum_time );
//    std::cerr << "Constructor Monitor" << std::endl;
}

Monitor::~Monitor(){
    ddv->monitor_stop();
//    std::cerr << "Destructor Monitor:" ;
}

void Monitor::action() {

}

