#ifndef _MODES_H
#define _MODES_H

#include "configs.h"

class Device;
class Result;

class Mode {
protected:
    Config *cfg;
    Device *ddv;
    bool   break_mode;
    double up_time;
public:
    Mode( Config&, Device& );
    virtual ~Mode() {} // std::cerr << " Mode" << std::endl; }
    virtual void action() = 0;
    virtual int  life() { return (int)up_time; }
    virtual void stop_request() { break_mode = true; }
    virtual void set(int pos){}
};

class Monitor : public Mode {
    double scan_period;
    double accum_time;
public:
    Monitor( Config&, Device&, Result& );
    virtual ~Monitor();
    void action();
};


#endif
