#ifndef _DOME_DEVICE_H
#define _DOME_DEVICE_H

#include <string>
#include <vector>
#include <pthread.h>

#include "module.h"
#include "configs.h"
#include "deftypes.h"
#include "curtain.h"
#include "meteo.h"
#include "skys.h"

class Result;

class Device {
    Result* out;
    std::string device;
    RS485 rs485;
    std::auto_ptr<Curtain>  dome_controller;
    std::auto_ptr<Meteo>  meteo_station;
    std::auto_ptr<SkySens>  sky_sensor;
    static pthread_t Data_thread;
    static void* thread( void* );
    double scan_period;
    double accum_time;
    double accum_end;
    std::vector<MonitorInfo> accum;
    static bool expire;
//    static void catch_fault( int );
    static int proc_run;
public:
    Device( Config&, bool );
    ~Device();
    void set_out( Result* o ) { out = o; }
    void monitor_run( double, double );
    void monitor_result( MonitorInfo& );
    void monitor_stop();
    bool monitor_watch();
};

#endif
