#ifndef _DOME_H
#define _DOME_H

#include "sens_device.h"
#include "modes.h"
#include "results.h"

struct Sensors_CMD {
    std::string cfgfile;
    bool test_mode;
    bool back_mode;
    bool auto_init;
};

class Sensors {
    std::map<std::string, Mode*, Cmpi> tableMode;
    Config Sensorscfg;
    Device deviceSensors;
    Result meteoData;
    Monitor meteoScan;
    Mode*  the;
    static Sensors* self_ptr;
    const static int initLifeSec;
    const static int parkLifeSec;
    static pthread_t thread_id;
    Sensors();
   ~Sensors() {} // std::cerr << "Destructor Dome\n";}
    class Lock { // for self_ptr
        Lock(const Lock&);
        Lock& operator=(const Lock&);
        static pthread_mutex_t mtx;
    public:
        Lock() {pthread_mutex_lock(&mtx);}
        ~Lock() {pthread_mutex_unlock(&mtx);}
    };
public:
    static Sensors_CMD cmd;
    static void create();
    static void destroy();
    static void runproc() { device_ptr()->run(); }
    static Sensors* device_ptr();
    static bool exist() { return self_ptr != 0 ;}
    static int initLife() { return initLifeSec; }
    static int parkLife() { return parkLifeSec; }
    void run() { thread_id = pthread_self(); the->action(); }
    void set( const std::string&, const std::string& );
    std::string get( const std::string& );
    int  specify( const std::vector<std::string>& );
    int  stop( const std::vector<std::string>& );
    int  quit( const std::vector<std::string>& ){ return 0; }
    static bool works();
private:
    std::string data();
    std::string wind_gen();
    std::string get_voltage();
    std::string get_wind();
    std::string get_sky();
};


#endif
