#ifndef __LINUX_EVENT_H_
#define __LINUX_EVENT_H_

/*
*   socket/event.h is a part of programm carbon
*   $Id: callback.h,v 1.1.1.1 2007/09/09 16:50:18 matwey Exp $
*   Copyright (C) 2006  Matwey V. Kornilov
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation; either version 2 of the License, or
*   (at your option) any later version.
*
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
class Server;
class Client;

typedef void(Server::*SFUNC)();
typedef void(Server::*SFUNC1)(const DefinedSocketBase::SocketState);
typedef void(Server::*SFUNCE)(const DefinedSocketError&);

typedef void(Client::*CFUNC)();
typedef void(Client::*CFUNC1)(const DefinedSocketBase::SocketState);
typedef void(Client::*CFUNCE)(const DefinedSocketError&);

struct CBTableServSock {	// Server's CallBack function table for Server Socket
    SFUNC onAccepted;
    SFUNC1 onStateChanged;
    SFUNCE onError;
};

struct CBTableClientSock {	// Client's CallBack function table for Client Socket
    CFUNC onDataRecieved;
    CFUNC1 onStateChanged;
    CFUNCE onError;
};

class ServerSocketWithCalls: public DefinedServerSocket {
private:
    CBTableServSock* cbtable;
    Server* server;
    ServerSocketWithCalls(const ServerSocketWithCalls&);
    ServerSocketWithCalls& operator=(const ServerSocketWithCalls&);
protected:
    virtual void onStateChanged( const SocketBase::SocketState s );
    virtual void onAccepted();
    virtual void onError( const DefinedSocketError& e );
public:
    ServerSocketWithCalls( CBTableServSock*, Server* );
};

class ClientSocketWithCalls: public DefinedClientSocket {
private:
    CBTableClientSock* cbtable;
    Client* client;
    ClientSocketWithCalls(const ClientSocketWithCalls&);
    ClientSocketWithCalls& operator=(const ClientSocketWithCalls&);
protected:
    virtual void onStateChanged(const SocketBase::SocketState s );
    virtual void onDataRecieved();
    virtual void onError( const DefinedSocketError& e );
public:
    ClientSocketWithCalls( ServerSocketWithCalls*, CBTableClientSock*, Client* );
    ClientSocketWithCalls( CBTableClientSock*, Client* );
};

#endif // __LINUX_EVENT_H_
